Index: dnspython-1.12.0/dns/tokenizer.py
===================================================================
--- dnspython-1.12.0.orig/dns/tokenizer.py
+++ dnspython-1.12.0/dns/tokenizer.py
@@ -15,23 +15,24 @@
 
 """Tokenize DNS master file format"""
 
-import cStringIO
+from io import StringIO
 import sys
 
 import dns.exception
 import dns.name
 import dns.ttl
+from ._compat import long, text_type, binary_type
 
 _DELIMITERS = {
-    ' ' : True,
-    '\t' : True,
-    '\n' : True,
-    ';' : True,
-    '(' : True,
-    ')' : True,
-    '"' : True }
+    ' ': True,
+    '\t': True,
+    '\n': True,
+    ';': True,
+    '(': True,
+    ')': True,
+    '"': True}
 
-_QUOTING_DELIMITERS = { '"' : True }
+_QUOTING_DELIMITERS = {'"': True}
 
 EOF = 0
 EOL = 1
@@ -155,7 +156,9 @@ class Token(object):
         else:
             raise IndexError
 
+
 class Tokenizer(object):
+
     """A DNS master file format tokenizer.
 
     A token is a (type, value) tuple, where I{type} is an int, and
@@ -197,8 +200,12 @@ class Tokenizer(object):
         @type filename: string
         """
 
-        if isinstance(f, str):
-            f = cStringIO.StringIO(f)
+        if isinstance(f, text_type):
+            f = StringIO(f)
+            if filename is None:
+                filename = '<string>'
+        elif isinstance(f, binary_type):
+            f = StringIO(f.decode())
             if filename is None:
                 filename = '<string>'
         else:
@@ -257,7 +264,7 @@ class Tokenizer(object):
         @raises UngetBufferFull: there is already an ungotten char
         """
 
-        if not self.ungotten_char is None:
+        if self.ungotten_char is not None:
             raise UngetBufferFull
         self.ungotten_char = c
 
@@ -281,7 +288,7 @@ class Tokenizer(object):
                     return skipped
             skipped += 1
 
-    def get(self, want_leading = False, want_comment = False):
+    def get(self, want_leading=False, want_comment=False):
         """Get the next token.
 
         @param want_leading: If True, return a WHITESPACE token if the
@@ -295,7 +302,7 @@ class Tokenizer(object):
         @raises dns.exception.SyntaxError: input was badly formed
         """
 
-        if not self.ungotten_token is None:
+        if self.ungotten_token is not None:
             token = self.ungotten_token
             self.ungotten_token = None
             if token.is_whitespace():
@@ -352,7 +359,8 @@ class Tokenizer(object):
                             return Token(COMMENT, token)
                         elif c == '':
                             if self.multiline:
-                                raise dns.exception.SyntaxError('unbalanced parentheses')
+                                raise dns.exception.SyntaxError(
+                                    'unbalanced parentheses')
                             return Token(EOF)
                         elif self.multiline:
                             self.skip_whitespace()
@@ -415,7 +423,7 @@ class Tokenizer(object):
         @raises UngetBufferFull: there is already an ungotten token
         """
 
-        if not self.ungotten_token is None:
+        if self.ungotten_token is not None:
             raise UngetBufferFull
         self.ungotten_token = token
 
@@ -429,6 +437,8 @@ class Tokenizer(object):
             raise StopIteration
         return token
 
+    __next__ = next
+
     def __iter__(self):
         return self
 
@@ -458,7 +468,8 @@ class Tokenizer(object):
 
         value = self.get_int()
         if value < 0 or value > 255:
-            raise dns.exception.SyntaxError('%d is not an unsigned 8-bit integer' % value)
+            raise dns.exception.SyntaxError(
+                '%d is not an unsigned 8-bit integer' % value)
         return value
 
     def get_uint16(self):
@@ -471,7 +482,8 @@ class Tokenizer(object):
 
         value = self.get_int()
         if value < 0 or value > 65535:
-            raise dns.exception.SyntaxError('%d is not an unsigned 16-bit integer' % value)
+            raise dns.exception.SyntaxError(
+                '%d is not an unsigned 16-bit integer' % value)
         return value
 
     def get_uint32(self):
@@ -488,8 +500,9 @@ class Tokenizer(object):
         if not token.value.isdigit():
             raise dns.exception.SyntaxError('expecting an integer')
         value = long(token.value)
-        if value < 0 or value > 4294967296L:
-            raise dns.exception.SyntaxError('%d is not an unsigned 32-bit integer' % value)
+        if value < 0 or value > long(4294967296):
+            raise dns.exception.SyntaxError(
+                '%d is not an unsigned 32-bit integer' % value)
         return value
 
     def get_string(self, origin=None):
@@ -537,7 +550,9 @@ class Tokenizer(object):
 
         token = self.get()
         if not token.is_eol_or_eof():
-            raise dns.exception.SyntaxError('expected EOL or EOF, got %d "%s"' % (token.ttype, token.value))
+            raise dns.exception.SyntaxError(
+                'expected EOL or EOF, got %d "%s"' % (token.ttype,
+                                                      token.value))
         return token.value
 
     def get_ttl(self):
Index: dnspython-1.12.0/dns/tsig.py
===================================================================
--- dnspython-1.12.0.orig/dns/tsig.py
+++ dnspython-1.12.0/dns/tsig.py
@@ -23,6 +23,7 @@ import dns.exception
 import dns.hash
 import dns.rdataclass
 import dns.name
+from ._compat import long, string_types
 
 class BadTime(dns.exception.DNSException):
     """Raised if the current time is not within the TSIG's validity time."""
@@ -68,6 +69,7 @@ BADKEY = 17
 BADTIME = 18
 BADTRUNC = 22
 
+
 def sign(wire, keyname, secret, time, fudge, original_id, error,
          other_data, request_mac, ctx=None, multi=False, first=True,
          algorithm=default_algorithm):
@@ -93,9 +95,9 @@ def sign(wire, keyname, secret, time, fu
         ctx.update(keyname.to_digestable())
         ctx.update(struct.pack('!H', dns.rdataclass.ANY))
         ctx.update(struct.pack('!I', 0))
-    long_time = time + 0L
-    upper_time = (long_time >> 32) & 0xffffL
-    lower_time = long_time & 0xffffffffL
+    long_time = time + long(0)
+    upper_time = (long_time >> 32) & long(0xffff)
+    lower_time = long_time & long(0xffffffff)
     time_mac = struct.pack('!HIH', upper_time, lower_time, fudge)
     pre_mac = algorithm_name + time_mac
     ol = len(other_data)
@@ -119,12 +121,14 @@ def sign(wire, keyname, secret, time, fu
         ctx = None
     return (tsig_rdata, mac, ctx)
 
+
 def hmac_md5(wire, keyname, secret, time, fudge, original_id, error,
              other_data, request_mac, ctx=None, multi=False, first=True,
              algorithm=default_algorithm):
     return sign(wire, keyname, secret, time, fudge, original_id, error,
                 other_data, request_mac, ctx, multi, first, algorithm)
 
+
 def validate(wire, keyname, secret, now, request_mac, tsig_start, tsig_rdata,
              tsig_rdlen, ctx=None, multi=False, first=True):
     """Validate the specified TSIG rdata against the other input parameters.
@@ -144,13 +148,13 @@ def validate(wire, keyname, secret, now,
     (aname, used) = dns.name.from_wire(wire, current)
     current = current + used
     (upper_time, lower_time, fudge, mac_size) = \
-                 struct.unpack("!HIHH", wire[current:current + 10])
-    time = ((upper_time + 0L) << 32) + (lower_time + 0L)
+        struct.unpack("!HIHH", wire[current:current + 10])
+    time = ((upper_time + long(0)) << 32) + (lower_time + long(0))
     current += 10
     mac = wire[current:current + mac_size]
     current += mac_size
     (original_id, error, other_size) = \
-                  struct.unpack("!HHH", wire[current:current + 6])
+        struct.unpack("!HHH", wire[current:current + 6])
     current += 6
     other_data = wire[current:current + other_size]
     current += other_size
@@ -178,23 +182,6 @@ def validate(wire, keyname, secret, now,
         raise BadSignature
     return ctx
 
-_hashes = None
-
-def _maybe_add_hash(tsig_alg, hash_alg):
-    try:
-        _hashes[tsig_alg] = dns.hash.get(hash_alg)
-    except KeyError:
-        pass
-
-def _setup_hashes():
-    global _hashes
-    _hashes = {}
-    _maybe_add_hash(HMAC_SHA224, 'SHA224')
-    _maybe_add_hash(HMAC_SHA256, 'SHA256')
-    _maybe_add_hash(HMAC_SHA384, 'SHA384')
-    _maybe_add_hash(HMAC_SHA512, 'SHA512')
-    _maybe_add_hash(HMAC_SHA1, 'SHA1')
-    _maybe_add_hash(HMAC_MD5, 'MD5')
 
 def get_algorithm(algorithm):
     """Returns the wire format string and the hash module to use for the
@@ -204,24 +191,16 @@ def get_algorithm(algorithm):
     @raises NotImplementedError: I{algorithm} is not supported
     """
 
-    global _hashes
-    if _hashes is None:
-        _setup_hashes()
-
-    if isinstance(algorithm, (str, unicode)):
+    if isinstance(algorithm, string_types):
         algorithm = dns.name.from_text(algorithm)
 
-    if sys.hexversion < 0x02050200 and \
-       (algorithm == HMAC_SHA384 or algorithm == HMAC_SHA512):
-        raise NotImplementedError("TSIG algorithm " + str(algorithm) +
-                                  " requires Python 2.5.2 or later")
-
     try:
-        return (algorithm.to_digestable(), _hashes[algorithm])
+        return (algorithm.to_digestable(), dns.hash.hashes[algorithm])
     except KeyError:
         raise NotImplementedError("TSIG algorithm " + str(algorithm) +
                                   " is not supported")
 
+
 def get_algorithm_and_mac(wire, tsig_rdata, tsig_rdlen):
     """Return the tsig algorithm for the specified tsig_rdata
     @raises FormError: The TSIG is badly formed.
@@ -230,7 +209,7 @@ def get_algorithm_and_mac(wire, tsig_rda
     (aname, used) = dns.name.from_wire(wire, current)
     current = current + used
     (upper_time, lower_time, fudge, mac_size) = \
-                 struct.unpack("!HIHH", wire[current:current + 10])
+        struct.unpack("!HIHH", wire[current:current + 10])
     current += 10
     mac = wire[current:current + mac_size]
     current += mac_size
Index: dnspython-1.12.0/dns/ttl.py
===================================================================
--- dnspython-1.12.0.orig/dns/ttl.py
+++ dnspython-1.12.0/dns/ttl.py
@@ -16,6 +16,7 @@
 """DNS TTL conversion."""
 
 import dns.exception
+from ._compat import long
 
 class BadTTL(dns.exception.SyntaxError):
     pass
@@ -36,8 +37,8 @@ def from_text(text):
     else:
         if not text[0].isdigit():
             raise BadTTL
-        total = 0L
-        current = 0L
+        total = long(0)
+        current = long(0)
         for c in text:
             if c.isdigit():
                 current *= 10
@@ -45,13 +46,13 @@ def from_text(text):
             else:
                 c = c.lower()
                 if c == 'w':
-                    total += current * 604800L
+                    total += current * long(604800)
                 elif c == 'd':
-                    total += current * 86400L
+                    total += current * long(86400)
                 elif c == 'h':
-                    total += current * 3600L
+                    total += current * long(3600)
                 elif c == 'm':
-                    total += current * 60L
+                    total += current * long(60)
                 elif c == 's':
                     total += current
                 else:
@@ -59,6 +60,6 @@ def from_text(text):
                 current = 0
         if not current == 0:
             raise BadTTL("trailing integer")
-    if total < 0L or total > 2147483647L:
+    if total < long(0) or total > long(2147483647):
         raise BadTTL("TTL should be between 0 and 2^31 - 1 (inclusive)")
     return total
Index: dnspython-1.12.0/dns/update.py
===================================================================
--- dnspython-1.12.0.orig/dns/update.py
+++ dnspython-1.12.0/dns/update.py
@@ -15,6 +15,7 @@
 
 """DNS Dynamic Update Support"""
 
+
 import dns.message
 import dns.name
 import dns.opcode
@@ -22,8 +23,11 @@ import dns.rdata
 import dns.rdataclass
 import dns.rdataset
 import dns.tsig
+from ._compat import string_types
+
 
 class Update(dns.message.Message):
+
     def __init__(self, zone, rdclass=dns.rdataclass.IN, keyring=None,
                  keyname=None, keyalgorithm=dns.tsig.default_algorithm):
         """Initialize a new DNS Update object.
@@ -51,7 +55,7 @@ class Update(dns.message.Message):
         """
         super(Update, self).__init__()
         self.flags |= dns.opcode.to_flags(dns.opcode.UPDATE)
-        if isinstance(zone, (str, unicode)):
+        if isinstance(zone, string_types):
             zone = dns.name.from_text(zone)
         self.origin = zone
         if isinstance(rdclass, str):
@@ -85,7 +89,7 @@ class Update(dns.message.Message):
 
                 - ttl, rdtype, string..."""
 
-        if isinstance(name, (str, unicode)):
+        if isinstance(name, string_types):
             name = dns.name.from_text(name, None)
         if isinstance(args[0], dns.rdataset.Rdataset):
             for rds in args:
@@ -135,7 +139,7 @@ class Update(dns.message.Message):
 
                 - rdtype, [string...]"""
 
-        if isinstance(name, (str, unicode)):
+        if isinstance(name, string_types):
             name = dns.name.from_text(name, None)
         if len(args) == 0:
             rrset = self.find_rrset(self.authority, name, dns.rdataclass.ANY,
@@ -152,7 +156,7 @@ class Update(dns.message.Message):
                     self._add_rr(name, 0, rd, dns.rdataclass.NONE)
             else:
                 rdtype = args.pop(0)
-                if isinstance(rdtype, (str, unicode)):
+                if isinstance(rdtype, string_types):
                     rdtype = dns.rdatatype.from_text(rdtype)
                 if len(args) == 0:
                     rrset = self.find_rrset(self.authority, name,
@@ -193,16 +197,16 @@ class Update(dns.message.Message):
 
                 - rdtype, string..."""
 
-        if isinstance(name, (str, unicode)):
+        if isinstance(name, string_types):
             name = dns.name.from_text(name, None)
         if len(args) == 0:
-            rrset = self.find_rrset(self.answer, name,
-                                    dns.rdataclass.ANY, dns.rdatatype.ANY,
-                                    dns.rdatatype.NONE, None,
-                                    True, True)
+            self.find_rrset(self.answer, name,
+                            dns.rdataclass.ANY, dns.rdatatype.ANY,
+                            dns.rdatatype.NONE, None,
+                            True, True)
         elif isinstance(args[0], dns.rdataset.Rdataset) or \
-             isinstance(args[0], dns.rdata.Rdata) or \
-             len(args) > 1:
+            isinstance(args[0], dns.rdata.Rdata) or \
+                len(args) > 1:
             if not isinstance(args[0], dns.rdataset.Rdataset):
                 # Add a 0 TTL
                 args = list(args)
@@ -210,31 +214,31 @@ class Update(dns.message.Message):
             self._add(False, self.answer, name, *args)
         else:
             rdtype = args[0]
-            if isinstance(rdtype, (str, unicode)):
+            if isinstance(rdtype, string_types):
                 rdtype = dns.rdatatype.from_text(rdtype)
-            rrset = self.find_rrset(self.answer, name,
-                                    dns.rdataclass.ANY, rdtype,
-                                    dns.rdatatype.NONE, None,
-                                    True, True)
+            self.find_rrset(self.answer, name,
+                            dns.rdataclass.ANY, rdtype,
+                            dns.rdatatype.NONE, None,
+                            True, True)
 
     def absent(self, name, rdtype=None):
         """Require that an owner name (and optionally an rdata type) does
         not exist as a prerequisite to the execution of the update."""
 
-        if isinstance(name, (str, unicode)):
+        if isinstance(name, string_types):
             name = dns.name.from_text(name, None)
         if rdtype is None:
-            rrset = self.find_rrset(self.answer, name,
-                                    dns.rdataclass.NONE, dns.rdatatype.ANY,
-                                    dns.rdatatype.NONE, None,
-                                    True, True)
+            self.find_rrset(self.answer, name,
+                            dns.rdataclass.NONE, dns.rdatatype.ANY,
+                            dns.rdatatype.NONE, None,
+                            True, True)
         else:
-            if isinstance(rdtype, (str, unicode)):
+            if isinstance(rdtype, string_types):
                 rdtype = dns.rdatatype.from_text(rdtype)
-            rrset = self.find_rrset(self.answer, name,
-                                    dns.rdataclass.NONE, rdtype,
-                                    dns.rdatatype.NONE, None,
-                                    True, True)
+            self.find_rrset(self.answer, name,
+                            dns.rdataclass.NONE, rdtype,
+                            dns.rdatatype.NONE, None,
+                            True, True)
 
     def to_wire(self, origin=None, max_size=65535):
         """Return a string containing the update in DNS compressed wire
Index: dnspython-1.12.0/dns/wiredata.py
===================================================================
--- dnspython-1.12.0.orig/dns/wiredata.py
+++ dnspython-1.12.0/dns/wiredata.py
@@ -15,9 +15,9 @@
 
 """DNS Wire Data Helper"""
 
-import sys
 
 import dns.exception
+from ._compat import binary_type, string_types
 
 # Figure out what constant python passes for an unspecified slice bound.
 # It's supposed to be sys.maxint, yet on 64-bit windows sys.maxint is 2^31 - 1
@@ -25,19 +25,26 @@ import dns.exception
 # extra comparisons, duplicating code, or weakening WireData, we just figure
 # out what constant Python will use.
 
+
 class _SliceUnspecifiedBound(str):
+
     def __getslice__(self, i, j):
         return j
 
 _unspecified_bound = _SliceUnspecifiedBound('')[1:]
 
-class WireData(str):
+
+class WireData(binary_type):
     # WireData is a string with stricter slicing
+
     def __getitem__(self, key):
         try:
-            return WireData(super(WireData, self).__getitem__(key))
+            if isinstance(key, slice):
+                return WireData(super(WireData, self).__getitem__(key))
+            return bytearray(self.unwrap())[key]
         except IndexError:
             raise dns.exception.FormError
+
     def __getslice__(self, i, j):
         try:
             if j == _unspecified_bound:
@@ -53,6 +60,7 @@ class WireData(str):
             return WireData(super(WireData, self).__getslice__(i, j))
         except IndexError:
             raise dns.exception.FormError
+
     def __iter__(self):
         i = 0
         while 1:
@@ -61,11 +69,16 @@ class WireData(str):
                 i += 1
             except dns.exception.FormError:
                 raise StopIteration
+
     def unwrap(self):
-        return str(self)
+        return binary_type(self)
+
 
 def maybe_wrap(wire):
-    if not isinstance(wire, WireData):
-        return WireData(wire)
-    else:
+    if isinstance(wire, WireData):
         return wire
+    elif isinstance(wire, binary_type):
+        return WireData(wire)
+    elif isinstance(wire, string_types):
+        return WireData(wire.encode())
+    raise ValueError("unhandled type %s" % type(wire))
